%define major 11
%define libname %mklibname %{name} %{major}
%define develname %mklibname %{name} -d
%define staticdevelname %mklibname %{name} -d -s

Summary:	Tools for manipulating graphics files in netpbm supported formats
Name:		netpbm
Version:	10.73.31
Release:	%mkrel 1
License:	GPL Artistic MIT
Group:		Graphics
URL:		http://netpbm.sourceforge.net/
Source0:	netpbm-%{version}.tar.xz
Source1:	mf50-netpbm_filters
Source2:	test-images.tar.bz2
# current svn checkout of revision 3810 because the guide is not
# distributed with the source anymore
Source3:	userguide.tar.xz
Patch1:		netpbm-time.patch
Patch2:		netpbm-message.patch
Patch3:		netpbm-security-scripts.patch
Patch4:		netpbm-security-code.patch
Patch5:		netpbm-CVE-2017-2587.patch
Patch6:		netpbm-gcc4.patch
Patch7:		netpbm-bmptopnm.patch
Patch8:		netpbm-CAN-2005-2471.patch
Patch9:		netpbm-xwdfix.patch
Patch11:	netpbm-multilib.patch
Patch12:        netpbm-docfix.patch
Patch13:	netpbm-glibc.patch
Patch16:	netpbm-ppmfadeusage.patch
Patch17:	netpbm-fiasco-overflow.patch
Patch20:	netpbm-noppmtompeg.patch
Patch21:	netpbm-cmuwtopbm.patch
Patch22:	netpbm-pamtojpeg2k.patch
Patch23:	netpbm-manfix.patch
Patch24:	netpbm-ppmtopict.patch
Patch26:	netpbm-werror.patch
Patch27:	netpbm-disable-pbmtog3.patch
Patch28:	netpbm-pnmtops.patch
Patch29:	netpbm-config.patch
Patch30:	netpbm-camera.patch
Requires:	%{libname} = %{version}
BuildRequires:	flex
BuildRequires:	jasper-devel
BuildRequires:	jbig-devel
BuildRequires:	jpeg-devel
BuildRequires:	libtiff-devel
BuildRequires:	libxml2-devel
BuildRequires:	%{_lib}png1.6-devel
BuildRequires:	python
BuildRequires:	libx11-devel
BuildConflicts:	svgalib-devel
Buildroot:	%{_tmppath}/%{name}-%{version}-%{release}-buildroot

%description
The netpbm package contains a library of functions which support programs for
handling various graphics file formats, including .pbm (portable bitmaps), .pgm
(portable graymaps), .pnm (portable anymaps), .ppm (portable pixmaps) and
others.

%package -n	%{libname}
Summary:        A library for handling different graphics file formats
Group:          System/Libraries
Obsoletes:	%{mklibname netpbm 10}

%description -n	%{libname}
The netpbm package contains a library of functions which support programs for
handling various graphics file formats, including .pbm (portable bitmaps), .pgm
(portable graymaps), .pnm (portable anymaps), .ppm (portable pixmaps) and
others.

%package -n	%{develname}
Summary:	Development tools for programs which will use the netpbm libraries
Group:		Development/C
Requires:	%{libname} = %{version}
Provides:	lib%{name}-devel = %{version}-%{release}
Provides:	netpbm-devel = %{version}-%{release}
Obsoletes:	%{mklibname netpbm 10 -d}

%description -n	%{develname}
The netpbm-devel package contains the header files and programmer's
documentation for developing programs which can handle the various graphics
file formats supported by the netpbm libraries.

Install netpbm-devel if you want to develop programs for handling the graphics
file formats supported by the netpbm libraries. You'll also need to have the
netpbm package installed.

#%package -n	%{staticdevelname}
#Summary:	Static libraries for the netpbm libraries
#Group:		Development/C
#Requires:	%{develname} = %{version}
#Provides:	lib%{name}-static-devell = %{version}-%{release}
#Provides:	netpbm-static-devel = %{version}-%{release}
#Obsoletes:	%{mklibname netpbm 10 -d -s}

#%description -n	%{staticdevelname}
#The netpbm-devel package contains the static libraries (.a) for developing
#programs which can handle the various graphics file formats supported by the
#netpbm libraries.

#Install netpbm-devel if you want to develop programs for handling the graphics
#file formats supported by the netpbm libraries. You'll also need to have the
#netpbm package installed.

%prep

%setup -q -a2
tar -Jxf %SOURCE3

find . -type d -perm 0700 -exec chmod 755 {} \;
find . -type f -perm 0555 -exec chmod 755 {} \;
find . -type f -perm 0444 -exec chmod 644 {} \;

for i in `find . -type d -name CVS` `find . -type f -name .cvs\*` `find . -type f -name .#\*`; do
    if [ -e "$i" ]; then rm -rf $i; fi >&/dev/null
done

%patch1 -p1 -b .time
%patch2 -p1 -b .message
%patch3 -p1 -b .security-scripts
%patch4 -p1 -b .security-code
%patch5 -p1 -b .CVE-2017-2587
%patch6 -p1 -b .gcc4
%patch7 -p1 -b .bmptopnm
%patch8 -p1 -b .CAN-2005-2471
%patch9 -p1 -b .xwdfix
%patch11 -p1 -b .multilib
%patch12 -p1 -b .docfix
%patch13 -p1 -b .glibc
%patch16 -p1 -b .ppmfadeusage
%patch17 -p1 -b .fiasco-overflow
%patch20 -p1 -b .noppmtompeg
%patch21 -p1 -b .cmuwtopbmfix
%patch23 -p1 -b .manfix
%patch22 -p1 -b .pamtojpeg2kfix
%patch24 -p1 -b .ppmtopict
%patch26 -p1 -b .werror
%patch27 -p1 -b .disable-pbmtog3
%patch28 -p1 -b .pnmtops
%patch29 -p1 -b .config

sed -i 's/PNGVER = .*/PNGVER = 16/g' config.mk.in

rm -rf converter/other/jpeg2000/libjasper/
rm -rf converter/other/jbig/libjbig/

rm -f userguide/pammixmulti.html


%build
%serverbuild

./configure <<EOF



















EOF

TOP=`pwd`
make \
    CC="%{__cc}" \
    LDFLAGS="$RPM_OPT_FLAGS -L$TOP/pbm -L$TOP/pgm -L$TOP/pnm -L$TOP/ppm %ldflags" \
    CFLAGS="$RPM_OPT_FLAGS $CFLAGS -fPIC -flax-vector-conversions -fno-strict-aliasing" \
    #CFLAGS_CONFIG="$RPM_OPT_FLAGS" \
    LADD="-lm" \
    TIFFLIB_DIR=%{_libdir} \
    TIFFLIB=-ltiff \
    TIFFINC_DIR=%{_includedir} \
    TIFFHDR_DIR=%{_includedir} \
    JPEGLIB_DIR=%{_libdir} \
    JPEGLIB=-ljpeg \
    JPEGHDR_DIR=%{_includedir} \
    JPEGINC_DIR=%{_includedir} \
    PNGLIB_DIR=%{_libdir} \
    PNGLIB=-lpng \
    PNGINC_DIR=%{_includedir} \
    PNGHDR_DIR=%{_includedir} \
    ZLIB_DIR=%{_libdir} \
    ZLIB=-lz \
    ZHDR_DIR=%{_includedir} \
    X11LIB_DIR=%{_libdir} \
    X11LIB=-lX11 \
    X11INC_DIR=%{_includedir} \
    X11HDR_DIR=%{_includedir} \
    JBIGLIB_DIR=%{_libdir} \
    JBIGLIB=-ljbig \
    JBIGHDR_DIR=%{_includedir} \
    JBIGHDR_DIR=%{_includedir} \
    JASPERLIB_DIR=%{_libdir} \
    JASPERLIB=-ljasper \
    JASPERHDR_DIR=%{_includedir} \
    JASPERDEPLIBS=-ljpeg \
    XML2LIBS="NONE" LINUXSVGALIB="NONE"

# prepare man files
cd userguide
rm -f *.manual-pages
rm -f *.manfix
for i in *.html ; do
    ../buildtools/makeman ${i}
done
for i in 1 3 5 ; do
    mkdir -p man/man${i}
    mv *.${i} man/man${i}
done

%install
rm -rf %{buildroot}

install -d %{buildroot}
make package pkgdir=%{buildroot}%{_prefix} XML2LIBS="NONE" LINUXSVGALIB="NONE"

# Ugly hack to have libs in correct dir on 64bit archs.
install -d %{buildroot}%{_libdir}
if [ "%{_libdir}" != "%{_prefix}/lib" ]; then
    mv %{buildroot}%{_prefix}/lib/lib* %{buildroot}%{_libdir}
fi

install -m0644 lib/libnetpbm.a %{buildroot}%{_libdir}/libnetpbm.a
ln -sf libnetpbm.so.%{major} %{buildroot}%{_libdir}/libnetpbm.so

# fix manpages
install -d %{buildroot}%{_mandir}
cp -rp userguide/man/* %{buildroot}%{_mandir}/

# Get rid of the useless non-ascii character in pgmminkowski.1
sed -i 's/\xa0//' %{buildroot}%{_mandir}/man1/pgmminkowski.1

# Don't ship man pages for non-existent binaries and bogus ones
for i in hpcdtoppm pcdovtoppm pnmtojbig ppmsvgalib vidtoppm picttoppm jbigtopnm \
    directory error extendedopacity pam pbm pgm pnm ppm index libnetpbm_dir liberror \
    pambackground pamfixtrunc pamtogif pamtooctaveimg pamundice ppmtotga; do
    rm -f %{buildroot}%{_mandir}/man1/${i}.1
done
rm -f %{buildroot}%{_mandir}/man5/extendedopacity.5

install -d %{buildroot}%{_datadir}/%{name}-%{version}
mv %{buildroot}%{_prefix}/misc/*.map %{buildroot}%{_datadir}/%{name}-%{version}
rm -rf %{buildroot}%{_prefix}/README
rm -rf %{buildroot}%{_prefix}/VERSION
rm -rf %{buildroot}%{_prefix}/link
rm -rf %{buildroot}%{_prefix}/misc
rm -rf %{buildroot}%{_prefix}/man
rm -rf %{buildroot}%{_prefix}/pkginfo
rm -rf %{buildroot}%{_prefix}/config_template

mkdir -p %{buildroot}/%{_libdir}/pkgconfig
mv %{buildroot}%{_prefix}/pkgconfig_template %{buildroot}/%{_libdir}/pkgconfig/%{name}.pc
# process the template values
sed -i 's|@VERSION@|%{version}|g' %{buildroot}/%{_libdir}/pkgconfig/%{name}.pc
sed -i 's|@INCLUDEDIR@|%{_includedir}|g' %{buildroot}/%{_libdir}/pkgconfig/%{name}.pc
sed -i 's|@LINKDIR@|%{_libdir}|g' %{buildroot}/%{_libdir}/pkgconfig/%{name}.pc

install -d %{buildroot}%{_datadir}/printconf/mf_rules
cp %{SOURCE1} %{buildroot}%{_datadir}/printconf/mf_rules/

install -d %{buildroot}%{_datadir}/printconf/tests
cp test-images/* %{buildroot}%{_datadir}/printconf/tests/

%multiarch_includes %{buildroot}%{_includedir}/netpbm/pm_config.h

# Don't ship the static library
find %{buildroot} -name '*.a' -delete

# remove/symlink/substitute obsolete utilities
pushd %{buildroot}%{_bindir}
rm -f pgmtopbm pnmcomp
ln -s pamcomp pnmcomp
echo -e '#!/bin/sh\npamditherbw $@ | pamtopnm\n' > pgmtopbm
chmod 0755 pgmtopbm
popd

rm -rf %{buildroot}%{_prefix}/{sharedlink,staticlink}

%check
pushd test
export LD_LIBRARY_PATH=%{buildroot}%{_libdir}
export PBM_TESTPREFIX=%{buildroot}%{_bindir}
export PBM_BINPREFIX=%{buildroot}%{_bindir}
./Execute-Tests && exit 0
popd

%post   -n %{libname}
/sbin/ldconfig

%postun -n %{libname}
/sbin/ldconfig


%clean
rm -rf %{buildroot}

%files
%defattr(-,root,root)
%attr(0755,root,root) %{_bindir}/*
%{_datadir}/%{name}-%{version}
%dir %{_datadir}/printconf
%dir %{_datadir}/printconf/mf_rules
%dir %{_datadir}/printconf/tests
%{_datadir}/printconf/mf_rules/*
%{_datadir}/printconf/tests/*
%{_mandir}/man[15]/*

%files -n %{libname}
%defattr(-,root,root)
%doc doc/*
%attr(0755,root,root) %{_libdir}/lib*.so.%{major}*

%files -n %{develname}
%defattr(-,root,root)
%dir %{_includedir}/netpbm
%{_includedir}/netpbm/*.h
%{multiarch_includedir}/netpbm/pm_config.h
%attr(0755,root,root) %{_libdir}/lib*.so
%{_mandir}/man3/*
%{_libdir}/pkgconfig/%{name}.pc

#%files -n %{staticdevelname}
#%defattr(-,root,root)
#%attr(0644,root,root) %{_libdir}/*.a


%changelog
* Wed May 20 2020 ghostbunny <ghostbunny at gmx dot de> 10.73.31-1pclos2020
- update to latest super stable release for new jasper version
- update patches with ones from arch and mga
- remove duplicated BRs
- remove static devel package

* Sat Sep 10 2011 Texstar <texstar at gmail.com> 10.47.29-1pclos2011
- 10.47.29

* Mon Jul 25 2011 Texstar <texstar at gmail.com> 10.47.27-1pclos2011
- sync with netpbm-10.47.27-1.fc16.src.rpm

